clc;
close all;
clear all;
tic

%Typical BCJR algo
%===============================Parameters================================
N = 8;             % Length of Packet
Niter=12;           % Number of Iteration
frames=10^3;        % The Least Number of Packets to send
gen_func=GeneratorFunction_debug(5,7);
[n,K]=size(gen_func);
M=(K-1);            % Memory Size
ev1=[];             % Error Vectors for Interleaver 1
ev_intv1=[];
ev2=[];             % Error Vectors for Interleaver 2
ev1_wt = [];        % Weight of Error Vector for Interleaver 1
par1_wt = [];       % Parity Weight for Component Code 1 of Interleaver 1 Error Vector 
par2_wt = [];       % Parity Weight for Component Code 2 of Interleaver 1 Error Vector
cw_wt = [];         % Codeword Weight for Error Vector for Interleaver 1

% tau=3;
D=[117 70];
EbNo_dB=2;
rate=1/(n+1);
EbNo=10.^(EbNo_dB./10);
L_c = (4*1*(EbNo*rate));
yu1=QPPInterleaver( 15,32,N);
interleaver=[yu1]+1; %interleaving rule

rng('default') % for debug purposes


for Ind_snr=1:length(EbNo)
    nep = zeros(size(interleaver,1),Niter); % Number of Error Packets
    SNR_dB=EbNo_dB(Ind_snr)+10*log10(rate);
    sigma=10.^(-SNR_dB/20);
    
    ind_packet = 1;
    Error_packet=zeros(1,size(interleaver,1));
    
    while (ind_packet<=frames) % &  (sum(Error_packet>=100)~=size(interleaver,1))
       ind_packet
        
        msg=(randi([0 1],1,N));
        noise=1/sqrt(2)*[randn(1,N*(n+1)) + 1i*randn(1,N*(n+1))];
        for j= 1:size(interleaver,1)
            
            %============================Encoding =================================
            [code,es1,es2]=(TurboCodeGeneratorBlock_debug( msg,interleaver(j,:), gen_func,1,true )); %Becareful here turbo code 0=>-1, 1=>1
            %===========================BPSK Modulation==============================
            mod_code=2*code-1; %0=>-1, 1=>1
            
            %===========================AWGN Transmission===========================
            
            r=mod_code+(sigma*noise);
            
            %============================Pre-Decoding===============================
            y = real(DemuxBlock2(r,[interleaver(j,:)],n ));
            nbe=zeros(1,Niter);
            %========================~~~BCJR decoding===============================
            for iter = 1:Niter
                
                if iter<2
                    Lu1=zeros(1,N); % Initialize extrinsic information
                else
                    Lu1=DeinterleavingBlock( L_e2,[interleaver(j,:)]); % (deinterleaved) a priori information
                end
                
                
                % ====Decoder=== 1
                [L_A1, L_e1]=BCJRDecodingBlock_debug( y(1,:),gen_func,Lu1,L_c(Ind_snr),(es1));
                [iter sum([0.5*(sign(L_A1)+1)~=msg])];
                
                % ======Decoder==== 2
                Lu2 = InterleavingBlock( L_e1,interleaver(j,:)); % (interleaved) a priori information
                
                [L_A2, L_e2]=BCJRDecodingBlock_debug( y(2,:),gen_func,Lu2,L_c(Ind_snr),(es2));
                
                %=========Demodulation and Estimation==============
                L=DeinterleavingBlock( L_A2,[interleaver(j,:)]);
                l_sign=sign(L);
                
                mhat=floor((sign(DeinterleavingBlock( L_A2,interleaver(j,:)))+1)/2); % Estimate the message bits
                
                %============Count bit errors============
                nbe(iter)=sum(mhat(1:N)~=msg); % Number of bit errors
                
                if nbe(iter)~=0
                    ev = abs(msg-mhat(1:N));
                    ev_intv = InterleavingBlock(ev,interleaver(j,:));
                    ev1 = [ev1; [iter (ev)]];
                    ev_intv1 = [ev_intv1; ev_intv];
                end
                
            end
            if nbe(Niter)~=0
                ev1_wt=[ev1_wt sum(ev)];                                     % Calculate weight of Message Error Vector
                par1_wt = [par1_wt otherWeight( ev,N,gen_func,1)];           
                par2_wt = [par2_wt otherWeight( ev_intv,N,gen_func,1)];
                cw_wt = [cw_wt ev1_wt(end)+par1_wt(end)+par2_wt(end)];       % Calculate weight of Codeword for Message Error Vector
            end
            
            
            nep(j,:)=nep(j,:)+nbe;
            ber(:,j)=(nep(j,:)./(ind_packet*(N)));
            
        end
        ind_packet=ind_packet+1;
    end
    
    
    %================Graphics=====================
    figure(1)
    
    for j=1:size(interleaver,1)
        if j==1
            semilogy(1:Niter,ber(:,j),'-*r')
            hold on;
            
        elseif j==2
            semilogy(1:Niter,ber(:,j),'-*k')
        else
            semilogy(1:Niter,ber(:,j),'-og')
        end
    end
    
    grid on;
    
    for tt=1:size(ber,2)
        
        rc=find(ber(:,tt)~=0);
        if isempty(rc)
            BER(Ind_snr,tt)=0;
        else
            BER(Ind_snr,tt)=ber(rc(end),tt);
        end
    end
    
end

figure(2)


for j=1:size(interleaver,1)
    if j==1
        semilogy(EbNo_dB,BER(:,j),'*-r')
        hold on;
    elseif j==2
        semilogy(EbNo_dB,BER(:,j),'o-k')
    else
        semilogy(EbNo_dB,BER(:,j),'*-')
    end
end
grid on;


toc


