function [inputs, currentStates,nextStates,outputs ] = RSCencoderTrellis(gen_func )
%UNTITLED 
%This actually  generates the state table for a given RSC code
%The only input is the generator function represented by a binary vector
%For example, the 5,7 RSC encoder generator matrix will be written as
%[1 1 1; 1 0 1] where
%The feedback portion of the generartor matrix is on the first row 
%which is counter intuitive
%   Detailed explanation goes here

k=1;
[n,K]=size(gen_func);


%generate 0/1 inputs
inputs=[zeros(1,(2^K)/2);ones(1,(2^K)/2)];
inputs=inputs(:);



%generate current states
cs=0:(2^(k*(K-1))-1);
currentStates=[cs ;cs];
currentStates=de2bi(currentStates(:),'left-msb');
    
 %generate next states
 
     for j=1:length(inputs)
         NewInputs(j,:)=mod(sum([inputs(j) currentStates(j,:)].*gen_func(1,:)),2);
         nextStates(j,1)=NewInputs(j,:);
         
     end
     nextStates=[NewInputs currentStates(:,1:end-1)];
   
    %generate outputs
   outputs=inputs;
   for i=2:n
       for j=1:2^(K)
      outputs(j,i) =mod(sum(gen_func(i,:).*[NewInputs(j,:) currentStates(j,:)]),2);
       end
   end

end

