clc;
close all;
clear all;
tic
%Typical BCJR algo


%%
%===============================Parameters================================
N=64;
Niter=12;
frames=10^3; %number of messages to send
gen_func=GeneratorFunction_debug(5,7);
[n,K]=size(gen_func);
M=(K-1);
ev=[];
ev1=[];
tau=3;
D=[117 70];
EbNo_dB=2;
rate=1/(n+1);
EbNo=10.^(EbNo_dB./10);
L_c = (4*1*(EbNo*rate));
yu1=QPPInterleaver( 15,32,N);
interleaver=[yu1]+1; %interleaving rule
rng('default') % for debug purposes

%%
for ii=1:length(EbNo)
    noes = zeros(size(interleaver,1),Niter); % number of bit errrors
    SNR_dB=EbNo_dB(ii)+10*log10(rate);
    sigma=10.^(-SNR_dB/20);
    i=1;
    erCounter=zeros(1,size(interleaver,1));
    cnt1=1;
    cnt=cnt1;
    %%
    
    while i<=frames &  sum(erCounter>=100)~=size(interleaver,1)
        msg=rand(1,N)>0.5;
%          msg=(randi([0 1],1,N));
        noise=1/sqrt(2)*[randn(1,N*(n+1)) + 1i*randn(1,N*(n+1))];
        %%
        for j= 1:size(interleaver,1)
            
            %%
            %============================Encoding =================================
            [code,es1,es2]=(TurboCodeGeneratorBlock_debug( msg,interleaver(j,:), gen_func,1,true )); %Becareful here turbo code 0=>-1, 1=>1
            
            %%
            %===========================BPSK Modulation===============================
            
            mod_code=2*code-1; %0=>-1, 1=>1
            %%
            %===========================AWGN Transmission===========================
            
            r=mod_code+(sigma*noise);
            %%
            %============================Pre-Decoding===============================
            y = real(DemuxBlock2(r,[interleaver(j,:)],n ));
            noe=zeros(1,Niter);
            %%
            %========================~~~BCJR decoding===============================
             for iter = 1:Niter
                
                if iter<2
                    Lu1=zeros(1,N); % Initialize extrinsic information
                else
                    Lu1=DeinterleavingBlock( L_e2,[interleaver(j,:)]); % (deinterleaved) a priori information
                end
                if i==1647 & iter==1
                  i;  
                end
                %%
                % ====Decoder=== 1
                [L_A1, L_e1]=BCJRDecodingBlock_rw( y(1,:),gen_func,Lu1,L_c(ii),(es1),0);
                [iter sum([0.5*(sign(L_A1)+1)~=msg])];
                %%
                % ======Decoder==== 2
                Lu2 = InterleavingBlock( L_e1,interleaver(j,:)); % (interleaved) a priori information
                
                [L_A2, L_e2]=BCJRDecodingBlock_rw( y(2,:),gen_func,Lu2,L_c(ii),(es2),0);
                %%
                %=========Demodulation and Estimation==============
                L=DeinterleavingBlock( L_A2,[interleaver(j,:)]);
                l_sign=sign(L);
                
                mhat=floor((sign(DeinterleavingBlock( L_A2,interleaver(j,:)))+1)/2); % Estimate the message bits
                %%
                %============Count bit errors============
                noe(iter)=sum(mhat(1:N)~=msg); % Number of bit errors
                if(noe(iter)==0)
                    break
                end
                %
                
                
                
             end  
            %%
            %=========================Note Errors====================
            if noe(end)~=0
                erCounter(j)=erCounter(j)+1;
                
                
                if j==1 & ii==length(EbNo)
                    pos(cnt)=i;
                    tx_msg(cnt,:)=msg;
                    dec_msg(cnt,:)=mhat(1:N);
                    ev(cnt,:)= abs(msg-mhat(1:N));
                    ev_in(cnt,:)=InterleavingBlock(abs(msg-mhat(1:N)),interleaver(j,:));
                    par1_wt(cnt)=otherWeight( ev(cnt,:),N,gen_func,1);
                    par2_wt(cnt)=otherWeight( ev_in(cnt,:),N,gen_func,1);
                    er_wt(cnt)=sum(ev(cnt,:)')+par1_wt(cnt)+par2_wt(cnt);
                    cnt=cnt+1;
                    
                elseif  j==2 & ii==length(EbNo)
                    pos1(cnt1)=i;
                    ev1(cnt1,:)=abs(msg-mhat(1:N));
                    ev1_in(cnt1,:)=InterleavingBlock(abs(msg-mhat(1:N)),interleaver(j,:));
                    
                    par1_wt1(cnt1)=otherWeight( ev1(cnt1,:),N,gen_func,1);
                    par2_wt1(cnt1)=otherWeight( ev1_in(cnt1,:),N,gen_func,1);
                    er_wt1(cnt1)=sum(ev1(cnt1,:)')+par1_wt1(cnt1)+par2_wt1(cnt1);
                    cnt1=cnt1+1;
                end
                
            end
            
            noes(j,:)=noes(j,:)+noe;
            ber(:,j)=(noes(j,:)./(i*(N)));
            
        end
        %%
        i=i+1;
    end
    %%
    
    %================Graphics=====================
    figure(1)
    
    for j=1:size(interleaver,1)
        if j==1
            semilogy(1:Niter,ber(:,j),'-*r')
            hold on;
            
        elseif j==2
            semilogy(1:Niter,ber(:,j),'-*k')
        else
            semilogy(1:Niter,ber(:,j),'-og')
        end
    end
    
    grid on;
    
    for tt=1:size(ber,2)
        
        rc=find(ber(:,tt)~=0);
        if isempty(rc)
            BER(ii,tt)=0;
        else
            BER(ii,tt)=ber(rc(end),tt);
        end
    end
    
end
%%
figure(2)


for j=1:size(interleaver,1)
    if j==1
        semilogy(EbNo_dB,BER(:,j),'*-r')
        hold on;
    elseif j==2
        semilogy(EbNo_dB,BER(:,j),'o-k')
    else
        semilogy(EbNo_dB,BER(:,j),'*-')
    end
end
grid on;


toc


